%Script that loads the saved cascade (cascade.mat) into a real-time face
%detector.
%The student is supposed to write most parts of this script.

clear variables
load('features.mat');
load('cascade.mat');

%[imgtst, pathname] = uigetfile('*.*', 'Select image file');
%Itest=imread([pathname imgtst]);
Itest=imread('test3.bmp');
figure(2);
clf;
imshow(Itest);
%while(true)
%Itest = vcapg('fast');

%Itest=imcrop(Itest); % ############TAKE OUT IN GENERAL CASE

if length(size(Itest)) > 2
    Itest=rgb2gray(Itest);
end

Itest=double(Itest);
Itest= normImageF(Itest);	% normalize here is wrong, but sometimes get better results!

%%%%%%%%%%%%%%%%%%%%%%%%
% TAKE repeated chunk out of image FUNCTION GOES HERE
[row col]=size(Itest);
mindim=min(row,col);
cropsize=19;
patchi=19;
patchsize=19*19;
patchsizepad=20*20;
%alpha_thresh = sum(alpha_t_Array(1:T))/2; % threshold
isfacenum=0;
nSteps = size(cascade,1);
%count = 0;
minDist = 19;
for psize = 19:4:19%mindim %# PLAY WITH THIS ########################
    nFound = 0;
    found = [];
    for xplace=1:4:col-psize
        xplace
        for yplace=1:4:row-psize

            %%%%%%%%%%%%%%%%%%%%%%%
            [Ichunk, rect]=imcrop(Itest,[xplace yplace psize psize]); %[xmin ymin width height]
            Ichunkoriginal=Ichunk;
            Ichunk=imresize(Ichunk,[cropsize,cropsize]);

            Ichunk=reshape(Ichunk,1,cropsize*cropsize);
            Ichunk= padJN(Ichunk);
            Ichunk=cumImageJN(Ichunk);

            face = 1;
            for i = 1:nSteps
                fNbestArray = cascade{i,1};
                thetaBestArray = cascade{i,2};
                pBestArray = cascade{i,3};
                alpha_t_Array = cascade{i,4};
                threshold = cascade{i,5};

                ht = %?
                hValue = %?
                hThreshold = %?
                if hValue < hThreshold
                    face=0;
                    break
                end
            end
            
            % This part "morphs" any duplicate (close) true positives.
            %========================================================
            if face
                isFound = 0;
                for i = 1:nFound
                    dist = norm([found(1,i)-xplace found(2,i)-yplace]);
                    if dist < minDist
                        isFound = 1;
                        found(1,i) = (found(3,i)*found(1,i)+xplace)/(found(3,i)+1);
                        found(2,i) = (found(3,i)*found(2,i)+yplace)/(found(3,i)+1);
                        found(3,i) = found(3,i)+1;
                        break
                    end
                end
                if ~isFound
                    nFound = nFound + 1;
                    found(1,nFound) = xplace;
                    found(2,nFound) = yplace;
                    found(3,nFound) = 1;
                end
                for i = 1:nFound
                    for j = 1:i-1
                        if found(3,i) == 0 | found(3,j) == 0
                            continue
                        end
                        dist = norm([found(1,i)-found(1,j) found(2,i)-found(2,j)]);
                        if dist < minDist
                            isFound = 1;
                            found(1,i) = (found(3,i)*found(1,i)+found(3,j)*found(1,j))/(found(3,i)+found(3,j));
                            found(2,i) = (found(3,i)*found(2,i)+found(3,j)*found(2,j))/(found(3,i)+found(3,j));
                            found(3,i) = found(3,i)+found(3,j);
                            found(3,j) = 0;
                        end
                    end
                end
                temp = nFound;
                for i = temp:-1:1
                    if found(3,i) == 0
                        found = [found(:,1:i-1) found(:,i+1:end)];
                        nFound = nFound - 1;
                    end
                end
            end
            %========================================================
            
        end
    end
    nFound
    for i = 1:nFound
        rect = [found(1,i) found(2,i) psize psize];
        rectangle('Position',rect,'edgecolor','red');drawnow;
    end
end
%end