% Train a Cascade of Boosted Classifiers

clear all
maxStage=10;    %Number of stages
fpath=which(mfilename); pathMF = fpath(1:findstr(upper(mfilename),upper(fpath))-1);
load('images.mat');
load('features.mat');
NFidx = 1:size(cumNonFaces,1);
%NFidx = 1:1000;
targetTP = 
%targetFP = linspace(0.9,0.3,10);
targetFP = 
nMax = 100;
tpTot = 1
fpTot = 1
cascade = cell(1);
nTot = 0;
for i=1:maxStage; 
    nNF = length(NFidx);
    disp(sprintf('Stage %d: nNF=%d', i,nNF));
    [fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,...
        tp,tn,threshold] = ...
            TrainAdaB_stage();  %<----- inputs to the function?
            
    n = length(fNbestArray);
    nTot =  %?
    tpTot = %?
    fpTot = %?
    disp(sprintf(...
        'n=%d, nTot=%d, tp=%.2g, tn=%.2g, tpTot=%.2g, fpTot=%.2g',...
        n,nTot,tp,tn,tpTot,fpTot));
    
    cascade{i,1} = fNbestArray;
    cascade{i,2} = thetaBestArray;
    cascade{i,3} = pBestArray;
    cascade{i,4} = alpha_t_Array;
    cascade{i,5} = threshold;

    fpIdx = findFP(fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,...
        cumNonFaces(NFidx,:),threshold);             % See help findFP for explanation of this function.                          
    NFidx = NFidx(fpIdx);
    
    nNF = length(NFidx);
    if nNF < 10 | nTot >= nMax
        break;
    end

end
save([pathMF 'cascade.mat' ], 'cascade');

