% makes a list of face and nonface file names

randFace = 1;      % randomly choose nonface file names 0/1
randNFace = 1;      % randomly choose nonface file names 0/1
numFaces=2000     %default
numNonFaces=4000     %default
filename = 'list_img.txt'


%psep = '\';  
%for linux/mac/unix users
psep = '\' 

if isempty(numFaces) return;end;

fotodir = strcat('..',psep,'ADAFACES'); 
d = dir(fotodir);           % what's inside
numimg =max(size({d.name}));   % just take this number first
outputfile = fopen(filename,'w'); % same dir as m file
count = 0;
ri=randperm(numimg);
fprintf(outputfile,'%s', 'FACES',char(13), char(10));   % start of face files
for j = 1:numimg
    if randFace
        i = ri(j);
    else
        i = j;
    end
    % if DIR OR not have bmp in WHOLE file name
    if d(i).isdir | isempty(findstr(upper(d(i).name),'BMP'))
        disp('Fileformat has to be BMP!');
    else
        count = count + 1;
        imgname = fprintf(outputfile,'%s', fotodir,psep,d(i).name,char(13), char(10));
        if count == numFaces;
            break;
        end   % only want so many 
    end
end
numFaces = count   % actual files used
fprintf(outputfile,'%s', 'NONFACES',char(13), char(10));    % start of nonface names


if isempty(numNonFaces) return;end;
fotodir = strcat('..',psep,'ADANFACES'); 
d = dir(fotodir);    % get BMP files only
numimg =max(size({d.name}));   % just take this number first
count = 0;
ri=randperm(numimg);
for j = 1:numimg
    if randNFace
        i = ri(j);
    else
        i = j;
    end
    % if DIR OR not have bmp in WHOLE file name
    if d(i).isdir | isempty(findstr(upper(d(i).name),'BMP')) 
        disp('Fileformat has to be BMP!');
    else
        count = count + 1;
        imgname = fprintf(outputfile,'%s', fotodir,psep,d(i).name,char(13), char(10));
        if count == numNonFaces;
            break;
        end   % only want so many 
    end
end
numNonFaces = count   % actual files used
fclose(outputfile);
