function I = padJNmat(preI) 
%  I = padJNmat(preI)
%
% takes an image preI and returns it as a matrix where it's been padded 
% with an extra left column and top row as zeros.

[m n] = size(preI);
I = [zeros(m+1,1) [zeros(1,n); preI]];