function c = violaboxcount(nI,nJ,nMin,nMax)
nI=nI+1;
nJ=nJ+1;
nPix = nI*nJ;
c=0; %count viola features for preallocation (for speedup)
for t = 1:6     % used to do only 4 - didn't want the center dot (t=6) not the split i 3 (t=3)!
    si=1; sj=1;
    switch t
        case 1, si=2; % split i 2
        case 2, sj=2; % split j 2
        case 3, si=3; % split i 3
        case 4, sj=3; % split j 3   % **** was 4
        case 5, si=2; sj=2; % split ij 2 % **** was 5
        case 6, si=3; sj=3; % center
    end
    si0 = si*ceil(nMin/si);
    sj0 = sj*ceil(nMin/sj);
    for i=2:nI;                 % start from 1!!!
        for j=2:nJ;
            nIend= min(i+nMax,nI);
            nJend= min(j+nMax,nJ);
            for i2=i+si0-1:si:nIend;
                for j2=j+sj0-1:sj:nJend;
                    c=c+1;
                    %c=c+2;      % store the dual as well!
                end;
            end;
        end;
    end;
end;
