function [truePos,trueNeg,selectedThrRat] = TestStage...
    (fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,x_test,y_test,targetTP)
%[truePos,trueNeg,selectedThrRat] =
%TestStage(fNbestArray,thetaBestArray,pBestArray,alpha_t_Array,x_test,y_test,targetTP)
% 
% Takes an set of features fNbestArray with corresponding thresholds
% thetaBestArray, parities pBestArray and weights alpha_t_Array over a set
% of test images x_test with correct classifications y_test and returns the
% true-positive rates truePos and true-negative rates trueNeg as well as
% the threhold ratio selectedThrRat.
% targetTP is the target true-positive rate.
%


load('features.mat');
yFace = find(y_test);
yNonFace = find(~y_test);
nSamples = length(y_test);
nFace = sum(y_test);
nNonFace = nSamples - nFace;
selectedThrRat = 0.5;

T = length(fNbestArray);   % num of features


%initialisation:


%ROC:


